﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Chop
{
    public class ResponseBuilder
    {
        private List<byte> Builder;

        public ResponseBuilder(short messageID)
        {
            Init(messageID);
        }
        public ResponseBuilder()
        {
            Builder = new List<byte>();
        }
        public void Init(short messageID)
        {
            Builder = new List<byte>();
            AppendInt16(messageID);
        }

        public void Append(object o)
        {
            Builder.AddRange(Encoding.UTF8.GetBytes(o.ToString()));
        }
        public void AppendChar(int i)
        {
            Append(Convert.ToChar(i));
        }
        public void AppendByte(byte b)
        {
            Builder.Add(b);
        }
        public void AppendString(string s)
        {
            Builder.AddRange(Reorder(BitConverter.GetBytes((short)s.Length)));
            Append(s);
        }
        public void AppendInt32(int i)
        {
            byte[] b = BitConverter.GetBytes(i);
            Array.Reverse(b);
            Builder.AddRange(b);
        }
        public void AppendInt16(short i)
        {
            byte[] b = BitConverter.GetBytes(i);
            Array.Reverse(b);
            Builder.AddRange(b);
        }
        public void AppendBoolean(bool b)
        {
            Builder.Add(b ? (byte)1 : (byte)0);
        }

        public List<byte> ToBytes()
        {
            List<byte> SendMessage = new List<byte>();

            SendMessage.AddRange(BitConverter.GetBytes(Builder.Count));
            SendMessage.Reverse();
            SendMessage.AddRange(Builder);
            return SendMessage;
        }
        public bool HasContent()
        {
            return Builder.Count > 2;
        }
        private byte[] Reorder(byte[] b)
        {
            Array.Reverse(b);
            return b;
        }

    }
}
