﻿using Chop;
using Chop.Game.Encryption;
using Chop.Game.Messages;
using Chop.Game.Messages.IDs;

namespace Game.Messages.Incoming.Handshake
{
    class InitCryptoMessageHandler : IMessageHandler
    {
        private static readonly BigInteger n =
    new BigInteger(
        "86851DD364D5C5CECE3C883171CC6DDC5760779B992482BD1E20DD296888DF91B33B936A7B93F06D29E8870F703A216257DEC7C81DE0058FEA4CC5116F75E6EFC4E9113513E45357DC3FD43D4EFAB5963EF178B78BD61E81A14C603B24C8BCCE0A12230B320045498EDC29282FF0603BC7B7DAE8FC1B05B52B2F301A9DC783B7",
        16);

        private static readonly BigInteger e = new BigInteger(3);

        private static readonly BigInteger d =
            new BigInteger(
                "59AE13E243392E89DED305764BDD9E92E4EAFA67BB6DAC7E1415E8C645B0950BCCD26246FD0D4AF37145AF5FA026C0EC3A94853013EAAE5FF1888360F4F9449EE023762EC195DFF3F30CA0B08B8C947E3859877B5D7DCED5C8715C58B53740B84E11FBC71349A27C31745FCEFEEEA57CFF291099205E230E0C7C27E8E1C0512B",
                16);
        public void Handle(GameClient client, RequestParser parser)
        {
            //client.Crypto = new Protocol(n, e, d);

            //client.Response.Init(277); // InitCryptoMessageEvent
            //client.Response.AppendString("sad9ascbn13f83d"); // token
            //client.Response.AppendBoolean(true); // isServerEncrypted
            //client.Response.AppendBoolean(false); // isClientEncrypted (not implemented in client)
            //client.SendResponse();

            client.Response.Init(OutgoingMessages.SessionParamsMessageEvent); // SessionParamsMessageEvent
            client.Response.AppendInt32(9); // pair count

            client.Response.AppendInt32(0);
            client.Response.AppendInt32(0); // coppa

            client.Response.AppendInt32(1); // voucher
            client.Response.AppendInt32(1);

            client.Response.AppendInt32(2); // parentEmailRequired
            client.Response.AppendInt32(0);

            client.Response.AppendInt32(3); // parentEmailRequiredInReRegistration
            client.Response.AppendInt32(0);

            client.Response.AppendInt32(4); // allowDirectEmail
            client.Response.AppendInt32(1);

            // All below are useless, client never uses them

            client.Response.AppendInt32(5); // date
            client.Response.AppendString("dd-MM-yyyy");

            //client.Response.AppendInt32(6); // confPartnerIntegration
            //client.Response.AppendString("dd-MM-yyyy");

            client.Response.AppendInt32(7); // allowProfileEditing
            client.Response.AppendInt32(1);

            client.Response.AppendInt32(8); // tracking_header
            client.Response.AppendString("/client");

            client.Response.AppendInt32(9); // tutorialEnabled
            client.Response.AppendInt32(1);

            client.SendResponse();
        }
    }
}
