﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Chop.Database;
using System.Data;

namespace Chop.Game.User
{
    public class RankManager
    {
        public List<Right> mRights;

        public void Init()
        {
            mRights = new List<Right>();

            using (DatabaseClient dbClient = Core.DatabaseManager.GetClient())
                foreach (DataRow row in dbClient.ReadDataTable("SELECT * FROM fuserights").Rows)
                    mRights.Add(Right.Parse(row));
        }
        public Right GetRight(string pRightName)
        {
            foreach (Right right in mRights)
                if (right.mName == pRightName)
                    return right;
            return null;
        }
        public bool RankHasRight(int pRankID, string pRightName)
        {
            return GetRight(pRightName).mMinimumRank <= pRankID;
        }
        public byte[] GetRights(byte pRankID)
        {
            ResponseBuilder Builder = new ResponseBuilder();

            foreach (Right right in mRights)
                if (right.mMinimumRank <= pRankID)
                    Builder.AppendString(right.mName);
            return Builder.ToBytes().ToArray();
        }
    }
}
