﻿/*
Thor Server 2.0 Project - Codenamed "Stockholm"
Copyright 2008 - 2009 Joe Hegarty


This file is part of The Thor Server 2.0 Project - Codenamed "Stockholm".

The Thor Server 2.0 Project - Codenamed "Stockholm" is free software: you can 
redistribute it and/or modify it under the terms of the Microsoft Public License

The Thor Server Project is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
Microsoft Public License for more details.

You should have received a copy of the Microsoft Public License
along with The Thor Server Project.  If not, see 
http://www.opensource.org/licenses/ms-pl.html
*/

using System;
using System.Collections.Generic;

using StockholmLibrary.Net;
using StockholmLibrary.Data;

namespace StockholmLibrary.Game.Packets.Server
{
    //------------------------------------
    public class FlatResultsPacket : ServerPacket
    {
        private List<Room> _flats;

        //**********************************************
        public FlatResultsPacket(List<Room> flats, bool isSearchResult)
        {
            _packetType = isSearchResult ? EServerPacket.FLAT_RESULTS : EServerPacket.FLAT_RESULTS_USER;
            _flats = flats;
        }

        //**********************************************
        protected override void SerialiseBody()
        {
            foreach (Room flat in _flats)
            {
                WriteDelimitedString(flat.RoomID.ToString(), 0x09);
                WriteDelimitedString(flat.RoomName, 0x09);
                WriteDelimitedString((bool)flat.ShowOwner ? flat.User.Username : "-", 0x09);
                WriteDelimitedString(flat.RoomState.StatusName, 0x09);
                WriteDelimitedString("x", 0x09);
                WriteDelimitedString("0", 0x09);
                WriteDelimitedString(flat.MaxGuests.ToString(), 0x09);
                WriteDelimitedString("null", 0x09);
                WriteDelimitedString(flat.RoomDescription, 0x09);
                WriteStringRaw("\r");
            }
        }
    }
}
